Index: issm/trunk/src/c/modules/SurfaceMassBalancex/Gembx.cpp
===================================================================
--- issm/trunk/src/c/modules/SurfaceMassBalancex/Gembx.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/SurfaceMassBalancex/Gembx.cpp	(revision 26744)
@@ -39,13 +39,11 @@
 	IssmDouble t,smb_dt;
    IssmDouble delta;
-	bool       isclimatology=false;
 	bool       linear_interp=true;
 
-	femmodel->parameters->FindParam(&linear_interp,TimesteppingInterpForcingsEnum); /*is interpolation requested*/
+	femmodel->parameters->FindParam(&linear_interp,TimesteppingInterpForcingEnum); /*is interpolation requested*/
 	femmodel->parameters->FindParam(&time,TimeEnum);                        /*transient core time at which we run the smb core*/
    femmodel->parameters->FindParam(&dt,TimesteppingTimeStepEnum);          /*transient core time step*/
 	femmodel->parameters->FindParam(&finaltime,TimesteppingFinalTimeEnum);
    femmodel->parameters->FindParam(&smb_dt,SmbDtEnum);                     /*time period for the smb solution,  usually smaller than the glaciological dt*/
-	femmodel->parameters->FindParam(&isclimatology,SmbIsclimatologyEnum);
 
 	//before starting loop, realize that the transient core runs this smb_core at time = time +deltaT.
@@ -63,18 +61,4 @@
 
 			timeclim=time;
-			if (isclimatology){
-				//If this is a climatology, we need to repeat the forcing after the final time
-				TransientInput* Ta_input_tr  = element->inputs->GetTransientInput(SmbTaEnum);    _assert_(Ta_input_tr);
-
-				/*Get temperature climatology value*/
-				int offsetend = Ta_input_tr->GetTimeInputOffset(finaltime);
-				IssmDouble time0     = Ta_input_tr->GetTimeByOffset(-1);
-				IssmDouble timeend   = Ta_input_tr->GetTimeByOffset(offsetend);
-				timeend   = ceil(timeend/dt)*dt;
-				if (time>time0 & timeend>time0){
-					delta=(time-time0) - (timeend-time0)*(reCast<int,IssmDouble>((time-time0)/(timeend-time0)));
-					timeclim=time0+delta;
-				}
-			}
 			if (linear_interp) timeinputs = t-time+timeclim;
 			else timeinputs = t-time+timeclim+smb_dt/2;
@@ -197,4 +181,80 @@
 
 } /*}}}*/
+IssmDouble gardnerAlb(IssmDouble* re, IssmDouble* dz, IssmDouble* d, IssmDouble clabSnow, IssmDouble clabIce, IssmDouble SZA, IssmDouble COT, IssmDouble dPHC, int m){ /*{{{*/
+	//gardnerAlb(S1, c1, SZA, t, z1, S2, c2)
+	//This is an implementation of the snow and ice broadband albedo
+	//  parameterization developed by Alex Gardner.
+	//Created By: Alex S. Gardner, Jet Propulsion Laboratory [alex.s.gardner@jpl.nasa.gov]
+	//  Last Modified: June, 2014
+	//Full Reference: Gardner, A. S., and Sharp, M. J.: A review of snow and
+	//  ice albedo and the development of a new physically based broadband albedo
+	//  parameterization, J. Geophys. Res., 115, F01009, 10.1029/2009jf001444,
+	//  2010.
+
+	//INPUTS
+	// ONE LAYER
+	//  - S1    : specific surface area of the snow or ice [cm^2 g-1]
+	//  - c1    : concentration of light absorbing carbon  [ppm1]
+	//  - SZA   : solar zenith angle of the incident radiation [deg]
+	//  - t     : cloud optical thickness
+	// TWO LAYER
+	//  - z1    : depth of snow suface layer [mm w.e.]
+	//  - S2    : specific surface area of bottom ice layer [cm^2 g-1]
+	//  - c2    : concentration of light absorbing carbon of bottom ice
+	//             layer [ppm1]
+	IssmDouble c1=clabSnow;
+	IssmDouble c2=clabIce;
+	IssmDouble t=COT;
+	IssmDouble a=0.0;
+
+	//Single layer albedo parameterization
+	//convert effective radius to specific surface area [cm2 g-1]
+	IssmDouble S1 = 3.0 / (0.091 * re[0]);
+
+	//effective solar zenith angle
+	IssmDouble x = min(pow(t/(3*cos(Pi*SZA/180.0)),0.5), 1.0);
+	IssmDouble u = 0.64*x + (1-x)*cos(Pi*SZA/180.0);
+
+	// pure snow albedo
+	IssmDouble as = 1.48 - pow(S1,-0.07);
+
+	//change in pure snow albedo due to soot loading
+	IssmDouble dac = max(0.04 - as, pow(-c1,0.55)/(0.16 + 0.6*pow(S1,0.5) + (1.8*pow(c1,0.6))*pow(S1,-0.25)));
+
+	//Two layer albedo parameterization
+	//  do two layer calculation if there is more than 1 layer
+	IssmDouble z1=0.0;
+	int lice=0;
+	for(int l=0;(l<m & d[l]<dPHC-Dtol);l++){
+		z1=z1+dz[l]*d[l]; //mm
+		lice=l+1;
+	}
+	if (m>0 & lice<m & z1 > Dtol){
+		// determine albedo values for bottom layer
+		IssmDouble S2 = 3.0 / (0.091 * re[lice]);
+
+		// pure snow albedo
+		IssmDouble as2 = 1.48 - pow(S2,-0.07);
+
+		// change in pure snow albedo due to soot loading
+		IssmDouble dac2 = max(0.04 - as2, pow(-c2,0.55)/(0.16 + 0.6*pow(S1,0.5) + (1.8*pow(c2,0.6))*pow(S2,-0.25)));
+
+		// determine the effective change due to finite depth and soot loading
+		IssmDouble A = min(1.0, (2.1 * pow(z1,1.35*(1-as) - 0.1*c1 - 0.13)));
+
+		dac =  (as2 + dac2 - as) + A*((as + dac) - (as2 + dac2));
+	}
+
+	// change in albedo due to solar zenith angle
+	IssmDouble dasz = 0.53*as*(1 - (as + dac))*pow(1 - u,1.2);
+
+	// change in albedo due to cloud (apart from change in diffuse fraction)
+	IssmDouble dat = (0.1*t*pow(as + dac,1.3)) / (pow(1 + 1.5*t,as));
+
+	// Broadband albedo
+	a = as + dac + dasz + dat;
+
+	return a;
+}   /*}}}*/
 void grainGrowth(IssmDouble** pre, IssmDouble** pgdn, IssmDouble** pgsp, IssmDouble* T,IssmDouble* dz,IssmDouble* d, IssmDouble* W,IssmDouble smb_dt,int m,int aIdx,int sid){ /*{{{*/
 
@@ -333,8 +393,8 @@
 			}
 			// dendricity and sphericity can not be > 1 or < 0
-         if (gdn[i]<0.0+Gdntol)gdn[i]=0.0;
-         if (gsp[i]<0.0+Gdntol)gsp[i]=0.0;
-         if (gdn[i]>1.0-Gdntol)gdn[i]=1.0;
-         if (gsp[i]>1.0-Gdntol)gsp[i]=1.0;
+         if (gdn[i]<=0.0+Gdntol)gdn[i]=0.0;
+         if (gsp[i]<=0.0+Gdntol)gsp[i]=0.0;
+         if (gdn[i]>=1.0-Gdntol)gdn[i]=1.0;
+         if (gsp[i]>=1.0-Gdntol)gsp[i]=1.0;
 
          // determine new grain size (mm)
@@ -344,7 +404,4 @@
 		else{
 
-			//When the state of "faceted crystals" (gsp==0) is fully reached,
-			// snow evolves towards depth hoar if the gradient is
-			// higher than 15 degC m-1 (Brun et al., 1992)
 			//When wet-snow grains (class 6) are submitted to a
 			// temperature gradient higher than 5 degC m-1, their sphericity
@@ -352,15 +409,26 @@
 			// reaches 0, their size increases according to the functions
 			// determined by Marbouty. (Brun et al., 1992)
-			if(gsp[i]>0.0+Gdntol && gsp[i]<1.0-Gdntol && (dT[i]>15.0+Ttol || (dT[i]>5.0+Ttol && W[i]>0.0+Wtol)) ){
-				//determine coefficients
-				IssmDouble C = (-2e8 * exp(-6e3 / T[i]) * dt) * pow(dT[i],.4);
-				gsp[i] +=C;
-				if (gsp[i]<0.0+Gdntol)gsp[i]=0.0;
-				//determine new grain size (mm)
-				gsz[i] = 0.35 + (0.5-gsp[i])*0.1;
-			}
+			if(gsp[i]>0.0+Gdntol && gsp[i]<1.0-Gdntol){
+
+				IssmDouble F = 0.0;
+
+				if (dT[i]>5.0+Ttol){
+					F = (-2e8 * exp(-6e3 / T[i]) * dt) * pow(dT[i],.4);
+				}
+				else if (W[i]>0.0+Wtol){
+					F = (1.0/16.0) * pow(lwc[i],3.0) * dt;
+				}
+				else{
+					F = 1e9 * exp(-6e3 / T[i]) * dt;
+				}
+				gsp[i] +=F;
+
+			}
+			if (gsp[i]<=0.0+Gdntol)gsp[i]=0.0;
+			if (gsp[i]>=1.0-Gdntol)gsp[i]=1.0;
+
 			/*Dry snow metamorphism (Marbouty, 1980) grouped model coefficents
 			 *from Marbouty, 1980: Figure 9*/
-			else if(W[i]<=0.0+Wtol || (gsp[i]<=0.0+Gdntol && dT[i]>15.0+Ttol) || (gsp[i]<=0.0+Gdntol && dT[i]>5.0+Ttol && W[i]>0.0+Wtol)){
+			if(W[i]<=0.0+Wtol || (gsp[i]<=0.0+Gdntol && dT[i]>5.0+Ttol)){
 				//_printf_("Nondendritic snow metamorphism\n");
 				Q = Marbouty(T[i],d[i],dT[i]);
@@ -402,5 +470,5 @@
 
 }  /*}}}*/
-void albedo(IssmDouble** pa, int aIdx, IssmDouble* re, IssmDouble* dz, IssmDouble* d, IssmDouble cldFrac, IssmDouble aIce, IssmDouble aSnow, IssmDouble aValue, IssmDouble adThresh, IssmDouble* TK, IssmDouble* W, IssmDouble P, IssmDouble EC, IssmDouble Msurf, IssmDouble t0wet, IssmDouble t0dry, IssmDouble K, IssmDouble dt, IssmDouble dIce, int m,int sid) { /*{{{*/
+void albedo(IssmDouble** pa, IssmDouble** padiff, int aIdx, IssmDouble* re, IssmDouble* dz, IssmDouble* d, IssmDouble cldFrac, IssmDouble aIce, IssmDouble aSnow, IssmDouble aValue, IssmDouble adThresh, IssmDouble* TK, IssmDouble* W, IssmDouble P, IssmDouble EC, IssmDouble Msurf, IssmDouble clabSnow, IssmDouble clabIce, IssmDouble SZA, IssmDouble COT, IssmDouble t0wet, IssmDouble t0dry, IssmDouble K, IssmDouble dt, IssmDouble dIce, int m,int sid) { /*{{{*/
 
 	//// Calculates Snow, firn and ice albedo as a function of:
@@ -424,6 +492,12 @@
 	// Methods 1 & 2
 	//   re      = surface effective grain radius [mm]
-
-	// Methods 3
+	// Method 1, optional
+	//  clabSnow = concentration of light absorbing carbon  [ppm1], default 0
+	//  SZA      = solar zenith angle of the incident radiation [deg], default 0
+	//  COT      = cloud optical thickness, default 0
+	//  For TWO LAYER
+	//  clabIce  = concentration of light absorbing carbon of first ice layer [ppm1], default 0
+
+	// Method 3
 	//   d       = snow surface density [kg m-3]
 	//   n       = cloud amount
@@ -431,5 +505,5 @@
 	//   aSnow   = albedo of fresh snow
 
-	// Methods 4
+	// Method 4
 	//   aIce    = albedo of ice
 	//   aSnow   = albedo of fresh snow
@@ -457,4 +531,5 @@
 	/*output: */
 	IssmDouble* a=NULL;
+	IssmDouble* adiff=NULL;
 
 	if(VerboseSmb() && sid==0 && IssmComm::GetRank()==0)_printf0_("   albedo module\n");
@@ -462,4 +537,5 @@
 	/*Recover pointers: */
 	a=*pa;
+	adiff=*padiff;
 
 	//some constants:
@@ -476,10 +552,7 @@
 		if(aIdx==1){ 
 			//function of effective grain radius
-
-			//convert effective radius to specific surface area [cm2 g-1]
-			IssmDouble S = 3.0 / (0.091 * re[0]);
-
-			//determine broadband albedo
-			a[0]= 1.48 - pow(S,-0.07);
+			// clabSnow, IssmDouble clabIce, IssmDouble SZA, IssmDouble COT, int m
+			a[0]=gardnerAlb(re, dz, d, clabSnow, clabIce, SZA, COT, dPHC, m);
+			adiff[0]=gardnerAlb(re, dz, d, clabSnow, clabIce, 50, COT, dPHC, m);
 		}
 		else if(aIdx==2){
@@ -572,5 +645,5 @@
 		//If we do not have fresh snow
 		if (aIdx<3 && aIdx>0 && (adThresh - d[0])>=Dtol){
-			// In a layer < 10cm, account for mix of ice and snow,
+			// In a snow layer < 10cm, account for mix of ice and snow,
 			// after P. Alexander et al., 2014
 			IssmDouble depthsnow=0.0;
@@ -618,7 +691,8 @@
 	/*Assign output pointers:*/
 	*pa=a;
+	*padiff=adiff;
 
 }  /*}}}*/
-void thermo(IssmDouble* pEC, IssmDouble** pT, IssmDouble* pulwrf, IssmDouble* dz, IssmDouble* d, IssmDouble* swf, IssmDouble dlwrf, IssmDouble Ta, IssmDouble V, IssmDouble eAir, IssmDouble pAir, IssmDouble teValue, IssmDouble Ws, IssmDouble dt0, int m, IssmDouble Vz, IssmDouble Tz, IssmDouble thermo_scaling, IssmDouble dIce, int sid, bool isconstrainsurfaceT) { /*{{{*/
+void thermo(IssmDouble* pEC, IssmDouble** pT, IssmDouble* pulwrf, IssmDouble* re, IssmDouble* dz, IssmDouble* d, IssmDouble* swf, IssmDouble dlwrf, IssmDouble Ta, IssmDouble V, IssmDouble eAir, IssmDouble pAir, IssmDouble eIdx, IssmDouble teValue, IssmDouble dulwrfValue, IssmDouble teThresh, IssmDouble Ws, IssmDouble dt0, int m, IssmDouble Vz, IssmDouble Tz, IssmDouble thermo_scaling, IssmDouble dIce, int sid, bool isconstrainsurfaceT, bool isdeltaLWup) { /*{{{*/
 
 	/* ENGLACIAL THERMODYNAMICS*/
@@ -936,7 +1010,12 @@
 
 		// upward longwave contribution
-		//ulw = - (SB * pow(Ts,4.0)* teValue) * dt; // - deltatest here
-		IssmDouble deltatest=0;
-		ulw = - (SB * pow(Ts,4.0)* teValue - deltatest) * dt; // - deltatest here
+		IssmDouble deltaULW=0.0;
+		IssmDouble emissivity=1.0;
+		//If user wants to set a upward long wave bias
+		if(isdeltaLWup) deltaULW = dulwrfValue;
+		//If user wants to directly set emissivity, or grain radius is larger than the
+		// threshold, or eIdx is 2 and we have wet snow or ice, use prescribed emissivity
+		if(eIdx==0 || (teThresh - re[0])<Gdntol || (eIdx==2 && z0>0.001)) emissivity = teValue;
+		ulw = - (SB * pow(Ts,4.0)* emissivity + deltaULW) * dt; 
 		ulwrf = ulwrf - ulw/dt0;
 
@@ -998,5 +1077,5 @@
 
 }  /*}}}*/
-void shortwave(IssmDouble** pswf, int swIdx, int aIdx, IssmDouble dsw, IssmDouble as, IssmDouble* d, IssmDouble* dz, IssmDouble* re, IssmDouble dIce, int m, int sid){ /*{{{*/
+void shortwave(IssmDouble** pswf, int swIdx, int aIdx, IssmDouble dsw, IssmDouble dswdiff, IssmDouble as, IssmDouble asdiff, IssmDouble* d, IssmDouble* dz, IssmDouble* re, IssmDouble dIce, int m, int sid){ /*{{{*/
 
 	// DISTRIBUTES ABSORBED SHORTWAVE RADIATION WITHIN SNOW/ICE
@@ -1005,5 +1084,5 @@
 
 	// swIdx = 1 : absorbed SW is distributed with depth as a function of:
-	//   default   : snow density (taken from Bassford, 2004)
+	//   default   : snow density (taken from Bassford, 2002)
 	//   if aIdx=2 : grain size in 3 spectral bands (Brun et al., 1992)
 
@@ -1012,5 +1091,7 @@
 	//   aIdx    = method for calculating albedo (1-4)
 	//   dsw     = downward shortwave radiative flux [w m-2]
+	//   dswdiff  = downward shortwave diffuse radiative flux [w m-2]
 	//   as      = surface albedo
+	//   asdiff  = surface albedo for diffuse radiation
 	//   d       = grid cell density [kg m-3]
 	//   dz      = grid cell depth [m]
@@ -1033,5 +1114,10 @@
 
 		// calculate surface shortwave radiation fluxes [W m-2]
-		swf[0] = (1.0 - as) * dsw;
+		if (aIdx == 1){
+			swf[0] = (1.0 - as) * max(0.0,(dsw - dswdiff)) +  (1.0 - asdiff) * dswdiff;
+		}
+		else{
+			swf[0] = (1.0 - as) * dsw;
+		}
 	}
 	else{ // sw radation is absorbed at depth within the glacier
@@ -1080,5 +1166,5 @@
 			swfS[2] = (sF[2] * dsw) * (1.0 - a2);
 
-			// absorption coeficient for spectral range:
+			// absorption coefficient for spectral range:
 			h =xNew<IssmDouble>(m);
 			B1 =xNew<IssmDouble>(m);
@@ -1197,5 +1283,5 @@
 
 } /*}}}*/ 
-void accumulation(IssmDouble** pT, IssmDouble** pdz, IssmDouble** pd, IssmDouble** pW, IssmDouble** pa, IssmDouble** pre, IssmDouble** pgdn, IssmDouble** pgsp, int* pm, int aIdx, int dsnowIdx, IssmDouble Tmean, IssmDouble T_air, IssmDouble P, IssmDouble dzMin, IssmDouble aSnow, IssmDouble C, IssmDouble V, IssmDouble Vmean, IssmDouble dIce, int sid){ /*{{{*/
+void accumulation(IssmDouble** pT, IssmDouble** pdz, IssmDouble** pd, IssmDouble** pW, IssmDouble** pa, IssmDouble** padiff, IssmDouble** pre, IssmDouble** pgdn, IssmDouble** pgsp, IssmDouble* pRa, int* pm, int aIdx, int dsnowIdx, IssmDouble Tmean, IssmDouble T_air, IssmDouble P, IssmDouble dzMin, IssmDouble aSnow, IssmDouble C, IssmDouble V, IssmDouble Vmean, IssmDouble dIce, int sid){ /*{{{*/
 
 	// Adds precipitation and deposition to the model grid
@@ -1213,8 +1299,9 @@
 	   dz = topgrid cell length [m]
 	   d = density of top grid gell [kg m-3]
-	   P = precipitation [mm w.e.] or [kg m-3]
-	   re = effective grain radius [mm]
-	   gdn = grain dentricity
-	   gsp = grain sphericity*/
+		P = precipitation [mm w.e.] or [kg m-3]
+		Ra = rainfall [mm w.e.] or [kg m-3]
+		re = effective grain radius [mm]
+		gdn = grain dentricity
+		gsp = grain sphericity*/
 
 	// MAIN FUNCTION
@@ -1238,7 +1325,9 @@
 	IssmDouble* W=NULL;
 	IssmDouble* a=NULL;
+	IssmDouble* adiff=NULL;
 	IssmDouble* re=NULL;
 	IssmDouble* gdn=NULL;
 	IssmDouble* gsp=NULL;
+	IssmDouble  ra=0.0;
 	int         m=0;
 
@@ -1251,8 +1340,10 @@
 	W=*pW;
 	a=*pa;
+	adiff=*padiff;
 	re=*pre;
 	gdn=*pgdn;
 	gsp=*pgsp;
 	m=*pm;
+	ra=*pRa;
 
 	//Density of fresh snow [kg m-3]
@@ -1266,5 +1357,5 @@
 			break;
 
-		case 2: // Density of Greenland snow, Fausto et al., 2008
+		case 2: // Density of Greenland snow, Fausto et al., 2018
 			dSnow = 315;
 			break;
@@ -1309,4 +1400,5 @@
 				newcell(&W,0.0,top,m); //new cell W
 				newcell(&a,aSnow,top,m); //new cell a
+				newcell(&adiff,aSnow,top,m); //new cell a
 				newcell(&re,refall,top,m); //new cell grain size
 				newcell(&gdn,dfall,top,m); //new cell grain dendricity
@@ -1355,4 +1447,6 @@
 				dz[0] = mass / d[0];    // dz is adjusted to conserve mass
 			}
+
+			ra=P;
 		}
 
@@ -1377,10 +1471,12 @@
 	*pW=W;
 	*pa=a;
+	*padiff=adiff;
 	*pre=re;
 	*pgdn=gdn;
 	*pgsp=gsp;
 	*pm=m;
+	*pRa=ra;
 } /*}}}*/
-void melt(IssmDouble* pM, IssmDouble* pMs, IssmDouble* pR, IssmDouble* pmAdd, IssmDouble* pdz_add, IssmDouble** pT, IssmDouble** pd, IssmDouble** pdz, IssmDouble** pW, IssmDouble** pa, IssmDouble** pre, IssmDouble** pgdn, IssmDouble** pgsp, int* pn, IssmDouble dzMin, IssmDouble zMax, IssmDouble zMin, IssmDouble zTop, IssmDouble zY, IssmDouble dIce, int sid){ /*{{{*/
+void melt(IssmDouble* pM, IssmDouble* pMs, IssmDouble* pR, IssmDouble* pF, IssmDouble* pmAdd, IssmDouble* pdz_add, IssmDouble** pT, IssmDouble** pd, IssmDouble** pdz, IssmDouble** pW, IssmDouble** pa, IssmDouble** padiff, IssmDouble** pre, IssmDouble** pgdn, IssmDouble** pgsp, int* pn, IssmDouble Ra, IssmDouble dzMin, IssmDouble zMax, IssmDouble zMin, IssmDouble zTop, IssmDouble zY, IssmDouble dIce, int sid){ /*{{{*/
 
 	//// MELT ROUTINE
@@ -1403,5 +1499,5 @@
 	IssmDouble* EW=NULL;
 	IssmDouble* M=NULL;
-	int*       D=NULL;
+	int*        D=NULL;
 
 	IssmDouble sumM=0.0;
@@ -1424,4 +1520,5 @@
 	IssmDouble W_bot=0.0;
 	IssmDouble a_bot=0.0;
+	IssmDouble adiff_bot=0.0;
 	IssmDouble re_bot=0.0;
 	IssmDouble gdn_bot=0.0;
@@ -1446,6 +1543,7 @@
 	IssmDouble  surplusE = 0.0;
 	IssmDouble  surplusT = 0.0;
-	IssmDouble dz_add = 0.0;
+	IssmDouble  dz_add = 0.0;
 	IssmDouble  Rsum = 0.0;
+	IssmDouble  Fsum = 0.0;
 	IssmDouble* T=*pT;
 	IssmDouble* d=*pd;
@@ -1453,4 +1551,5 @@
 	IssmDouble* W=*pW;
 	IssmDouble* a=*pa;
+	IssmDouble* adiff=*padiff;
 	IssmDouble* re=*pre;
 	IssmDouble* gdn=*pgdn;
@@ -1478,4 +1577,5 @@
 	// initialize melt and runoff scalars
 	Rsum = 0.0;       // runoff [kg]
+	Fsum = 0.0;       // refreeze [kg]
 	sumM = 0.0;       // total melt [kg]
 	mAdd = 0.0;       // mass added/removed to/from base of model [kg]
@@ -1523,4 +1623,13 @@
 
 	//// MELT, PERCOLATION AND REFREEZE
+
+	// initialize refreeze, runoff, flxDn and dW vectors [kg]
+	IssmDouble* F = xNewZeroInit<IssmDouble>(n);
+
+	// Add previous refreeze to F and reset dW
+	for(int i=0;i<n;i++){
+		F[i]=F[i]+dW[i];
+		dW[i] = 0.0;
+	}
 
 	// run melt algorithm if there is melt water or excess pore water
@@ -1573,5 +1682,5 @@
 		}
 		Msurf = M[0];
-		sumM = cellsum(M,n);                                                       // total melt [kg]
+		sumM = max(0.0,cellsum(M,n)-Ra);  // total melt [kg] minus the liquid rain that had been added
 
 		// calculate maximum refreeze amount, maxF [kg]
@@ -1579,8 +1688,6 @@
 
 		// initialize refreeze, runoff, flxDn and dW vectors [kg]
- 		IssmDouble* F = xNewZeroInit<IssmDouble>(n);
 		IssmDouble* R = xNewZeroInit<IssmDouble>(n);
 
-		for(int i=0;i<n;i++)dW[i] = 0.0;
 		flxDn=xNewZeroInit<IssmDouble>(n+1);
 
@@ -1595,4 +1702,5 @@
 
 		IssmDouble depthice=0.0;
+		int Xi=0;
 		//// meltwater percolation
 		for(int i=0;i<n;i++){
@@ -1620,5 +1728,4 @@
 				dW[i] = max(min(inM, Wi - W[i]),-1*W[i]);            // change in pore water
 				R[i] = max(0.0, inM - dW[i]);             // runoff
-				F[i] = 0.0;
 			}
 			// check if no energy to refreeze meltwater
@@ -1633,5 +1740,4 @@
 				flxDn[i+1] = max(0.0, inM - dW[i]);         // meltwater out
 				R[i] = 0.0;
-				F[i] = 0.0;                               // no freeze 
 			}
 			// some or all meltwater refreezes
@@ -1649,8 +1755,5 @@
 				//-----------------------pore water-----------------------------
 				Wi = (dIce-d[i])* Swi * dz_0;            // irreducible water 
-				dW[i] = min(inM - F1, Wi-W[i]);         // change in pore water
-				if (dW[i] < 0.0-Wtol && -1*dW[i]> W[i]-Wtol ){
-					dW[i]= -1*W[i];
-				}
+				dW[i] = max(min(inM - F1, Wi-W[i]),-1*W[i]);         // change in pore water
 				IssmDouble F2 = 0.0;                                 
 
@@ -1661,10 +1764,9 @@
 					m[i] = m[i] + F2;                   // mass after refreeze
 					d[i] = m[i]/dz_0;
-					dW[i] = dW[i] - F2;
 				}
 
-				F[i] = F1 + F2;
-
-				flxDn[i+1] = inM - F1 - dW[i];     // meltwater out        
+				F[i] = F[i] + F1 + F2;
+
+				flxDn[i+1] = max(0.0,inM - F1 - dW[i]);     // meltwater out        
 				if (m[i]>Wtol){
 					T[i] = T[i] + ((F1+F2)*(LF+(CtoK - T[i])*CI)/(m[i]*CI));// change in temperature
@@ -1680,4 +1782,5 @@
 				}
 			}
+			Xi=Xi+1;
 		}
 
@@ -1690,5 +1793,5 @@
 
 		//calculate Rsum:
-		Rsum=cellsum(R,n) + flxDn[n];
+		Rsum=cellsum(R,n) + flxDn[Xi];
 
 		// delete all cells with zero mass
@@ -1703,4 +1806,5 @@
 		celldelete(&T,n,D,D_size);
 		celldelete(&a,n,D,D_size);
+		celldelete(&adiff,n,D,D_size);
 		celldelete(&re,n,D,D_size);
 		celldelete(&gdn,n,D,D_size);
@@ -1715,7 +1819,12 @@
 
 		/*Free resources:*/
-		xDelete<IssmDouble>(F);
 		xDelete<IssmDouble>(R);
 	}
+
+	//calculate Fsum:
+	Fsum=cellsum(F,n);
+
+	/*Free resources:*/
+	xDelete<IssmDouble>(F);
 
 	//Merging of cells as they are burried under snow.
@@ -1765,4 +1874,5 @@
 			T[X1] = (T[X2]*m[X2] + T[X1]*m[X1]) / m_new;
 			a[X1] = (a[X2]*m[X2] + a[X1]*m[X1]) / m_new;
+			adiff[X1] = (adiff[X2]*m[X2] + adiff[X1]*m[X1]) / m_new;
 			re[X1] = (re[X2]*m[X2] + re[X1]*m[X1]) / m_new;
 			gdn[X1] = (gdn[X2]*m[X2] + gdn[X1]*m[X1]) / m_new;
@@ -1791,4 +1901,5 @@
 	celldelete(&T,n,D,D_size);
 	celldelete(&a,n,D,D_size);
+	celldelete(&adiff,n,D,D_size);
 	celldelete(&re,n,D,D_size);
 	celldelete(&gdn,n,D,D_size);
@@ -1828,4 +1939,5 @@
 			cellsplit(&d, n, j,1.0);
 			cellsplit(&a, n, j,1.0);
+			cellsplit(&adiff, n, j,1.0);
 			cellsplit(&EI, n, j,.5);
 			cellsplit(&EW, n, j,.5);
@@ -1856,4 +1968,5 @@
 		d_bot=d[n-1];
 		a_bot=a[n-1];
+		adiff_bot=adiff[n-1];
 		re_bot=re[n-1];
 		gdn_bot=gdn[n-1];
@@ -1870,4 +1983,5 @@
 		newcell(&d,d_bot,top,n);
 		newcell(&a,a_bot,top,n);
+		newcell(&adiff,adiff_bot,top,n);
 		newcell(&re,re_bot,top,n);
 		newcell(&gdn,gdn_bot,top,n);
@@ -1895,4 +2009,5 @@
 		celldelete(&d,n,D,D_size);
 		celldelete(&a,n,D,D_size);
+		celldelete(&adiff,n,D,D_size);
 		celldelete(&re,n,D,D_size);
 		celldelete(&gdn,n,D,D_size);
@@ -1946,4 +2061,5 @@
 	*pM=sumM;
 	*pR=Rsum;
+	*pF=Fsum;
 	*pmAdd=mAdd;
 	*pdz_add=dz_add;
@@ -1954,4 +2070,5 @@
 	*pW=W;
 	*pa=a;
+	*padiff=adiff;
 	*pre=re;
 	*pgdn=gdn;
@@ -2090,6 +2207,9 @@
 					if (fabs(adThresh - 820) < Dtol){
 						// ERA5 new aIdx=1, swIdx=0, MODIS 820
-						M0 = max(1.8230 - (0.1645 * log(C)),0.25);
-						M1 = max(2.5134 - (0.3244 * log(C)),0.25);
+						//M0 = max(1.8230 - (0.1645 * log(C)),0.25);
+						//M1 = max(2.5134 - (0.3244 * log(C)),0.25);
+						// ERA5 new aIdx=1, swIdx=0, MODIS 820, p90 new (ERA5, 40 and e97)
+						M0 = max(1.3045 - (0.0988 * log(C)),0.25);
+						M1 = max(1.3694 - (0.1354 * log(C)),0.25);
 					}
 					else{
@@ -2134,6 +2254,9 @@
 					if (fabs(adThresh - 820) < Dtol){
 						// ERA5 new aIdx=1, swIdx=0, MODIS 820
-						M0 = max(1.4174 - (0.1037 * log(C)),0.25);
-						M1 = max(2.2010 - (0.2460 * log(C)),0.25);
+						//M0 = max(1.4174 - (0.1037 * log(C)),0.25);
+						//M1 = max(2.2010 - (0.2460 * log(C)),0.25);
+						// ERA5 new aIdx=1, swIdx=0, MODIS 820, p90 new (ERA5 lwt, 40 and e97)
+						M0 = max(1.2138 - (0.1057 * log(C)),0.25);
+						M1 = max(1.4946 - (0.1607 * log(C)),0.25);
 					}
 					else{
